-------------------------- MODULE Messages -----------------------------------------

EXTENDS RoutingTable

msg_Lookup       == [type : {"Lookup"}, node: I] 
msg_NoLegalRoute == [type : {"NoLegalRoute"},  key: I]
msg_JoinRequest  == [type : {"JoinRequest"}, rt: RoutingTable, node: I] 
msg_JoinReply    == [type : {"JoinReply"}, rt: RoutingTable, ls: LeafSet] 
msg_Probe        == [type : {"Probe"}, node: I, ls: LeafSet, failed: SUBSET I] 
msg_ProbeReply   == [type : {"ProbeReply"}, node: I, ls: LeafSet, failed: SUBSET I] 
msg_LeaseRequest == [type : {"LeaseRequest"}, node: I]
msg_LeaseReply   == [type : {"LeaseReply"}, ls: LeafSet, grant: BOOLEAN]

MessageContent ==
  msg_Lookup \cup msg_NoLegalRoute \cup msg_JoinRequest \cup msg_JoinReply
  \cup msg_Probe \cup msg_ProbeReply \cup msg_LeaseRequest \cup msg_LeaseReply

Message == [destination: I, content: MessageContent]

===============================================================================
